#include <iostream>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <cstdlib>
#include <cstring>

using namespace std;

int N, A1[30][30], A2[30][30], A3[30][30], A4[30][30], I, J, C;

void reset(int A[30][30]) { for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) A[i][j]=0; }

void cpy(int Ad[30][30], int As[30][30]) { for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) Ad[i][j]=As[i][j]; }

void markDirty() { for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) if (A3[i][j]==1) A2[i][j]=-2; }

void findMax() { for (int i=0; i<N; ++i) for (int j=0; j<N; ++j)  if (A4[i][j]>A4[I][J]) {I=i, J=j;} }

//void print(int A[30][30]) { for (int i=0; i<N; ++i) { for (int j=0; j<N; ++j) cout<<setw(4)<<A[i][j]; cout<<endl; } cout<<endl; }

int isGood(int i,int j) {
	if ( A3[i][j]==1 ) return 0;
	if ( (i!=I||j!=J)&&A2[i][j]!=-1 ) return 0;
	if ( i>0 && A2[i-1][j]<-1 ) return 0;
	if ( j>0 && A2[i][j-1]<-1 ) return 0;
	if ( i<N-1 && A2[i+1][j]<-1 ) return 0;
	if ( j<N-1 && A2[i][j+1]<-1 ) return 0;
	
	return 1;
}

void flood(int i,int j) {
	if ( isGood(i,j) && C<A2[I][J]) {
		A3[i][j]=1;
		++C;
		if(i>0)flood(i-1,j);if(j>0)flood(i,j-1);if(i<N-1)flood(i+1,j);if(j<N-1)flood(i,j+1);
	}
}

int eval(int ii,int jj) { for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) if (A2[i][j]>-1) { reset(A3); C=0; flood(I=i, J=j); if (C==A2[i][j]) --A4[ii][jj]; } }

int main() {
	//clock_t clock1=clock();
	ifstream in("game.in",iostream::in);
	in>>N;
	for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) {char c[3]; in>>c; if (c[0]=='#') A1[i][j]=-1; else if (c[0]=='B') A1[i][j]=-2; else if (strlen(c)==2) A1[i][j]=10*(c[0]-'0')+(c[1]-'0'); else if (strlen(c)==1) A1[i][j]=c[0]-'0';}
	in.close();
	
	cpy(A2,A1);
	reset(A4);
	for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) if (A2[i][j]>-1) { cpy(A2,A1); reset(A3); C=0; flood(I=i, J=j); if (C==A2[i][j]) { A4[i][j]=1000; markDirty(); eval(i,j); } }


	findMax();

	cpy(A2,A1); reset(A3); C=0; flood(I, J);

	ofstream out("game.out",iostream::out);
	out<<C<<endl;
	for (int i=0; i<N; ++i) for (int j=0; j<N; ++j) if (A3[i][j]==1) out<<i<<" "<<j<<endl;
	out.close();
	
//system("pause");

	return 0;
}
